#!/bin/bash
# Starting daemons via RUN== in udev rules is not supported.
# In inst-sys systemd is not used, so start all daemons manually.
bindir=/usr/lib/hyper-v/bin
declare -a helpers
test -c /dev/vmbus/hv_kvp && helpers+=(hv_kvp_daemon)
test -c /dev/vmbus/hv_vss && helpers+=(hv_vss_daemon)
if test -c /dev/vmbus/hv_fcopy
then
	helpers+=(hv_fcopy_daemon)
else
	modprobe -v uio_hv_generic
	if test -f /sys/bus/vmbus/drivers/uio_hv_generic/new_id
	then
		echo '34d14be3-dee4-41c8-9ae7-6b174977c192' > /sys/bus/vmbus/drivers/uio_hv_generic/new_id
		helpers+=(hv_fcopy_uio_daemon)
	fi
fi
if test -d /sys/bus/vmbus/devices
then
	export PATH=${bindir}:$PATH
	echo -n "Starting hyper-v helpers:"
	for i in "${helpers[@]}"
	do
		if mkdir /run/$i
		then
			echo -n " $i"
			$i < /dev/null &
		fi
	done
	echo " ... done"
fi
